/*
Copyright (C) 2014 Graham Jones, www.indriid.com
*/

package stacey.debugtune;


import beast.evolution.tree.Tree;
import stacey.GtreeAndCoalFactor;
import stacey.util.*;

import java.util.ArrayList;

/**
 * Created by Graham Jones on 03/11/2014.
 */
public class Checks {






    static public boolean debugAllCompatible(OperatorsSMCTree opSmcTree, OperatorsGeneTree [] opGeneTrees) {
        boolean ok = true;
        for (int j = 0; j < opGeneTrees.length; j++) {
            ok &= debugFitsInSpeciesTree(opSmcTree, opGeneTrees[j]);
        }
        if (!ok) {
            System.out.println("BUG: Checks.debugAllCompatible()");
        }
        return ok;
    }


    private static boolean debugFitsInSpeciesTree(OperatorsSMCTree smcTree, OperatorsGeneTree opGeneTree) {
        OperatorsGeneTree.GeneUnionNode [] opGNodes = opGeneTree.getNodes();
        return debugSubtreeFitsInSpeciesTree(opGNodes, opGNodes.length-1, smcTree);
    }



    static private boolean debugSubtreeFitsInSpeciesTree(OperatorsGeneTree.GeneUnionNode [] opGNodes, int n, OperatorsSMCTree smcTree) {
        if (opGNodes[n].getLft() >= 0) {
            if (!debugSubtreeFitsInSpeciesTree(opGNodes, opGNodes[n].getLft(), smcTree)) {
                return false;
            }
            if (!debugSubtreeFitsInSpeciesTree(opGNodes, opGNodes[n].getRgt(), smcTree)) {
                return false;
            }
        }
        return debugCoalescenceIsCompatible(opGNodes[n].getHeight(), opGNodes[n].getUnion(), smcTree);
    }



    private static boolean debugCoalescenceIsCompatible(double height, BitUnion union, OperatorsSMCTree smcTree) {
        OperatorsSMCTree.SMCUnionNode [] opSNodes = smcTree.getNodes();
        int nn = UnionNode.Abstract.nodeIndexOfUnionInSubtree(opSNodes, opSNodes.length-1, union);
        boolean ok = opSNodes[nn].getHeight() <= height;
        if (!ok) {
            System.out.println("BUG: Checks.debugCoalescenceIsCompatible(). Node " + nn);
        }
        return ok;
    }


    public static void debugCheckCoalescences(PIOProbabilitySMCTree smcTree, PIOProbabilityGeneTree geneTree, int j) {
        geneTree.update();
        PIOProbabilityGeneTree.GeneUnionNode [] pioGNodes = geneTree.getNodes();
        subtreedebugCheckCoalescences(pioGNodes, pioGNodes.length - 1, j, smcTree);
    }

    static private void subtreedebugCheckCoalescences(PIOProbabilityGeneTree.GeneUnionNode [] pioGNodes, int n, int j, PIOProbabilitySMCTree smcTree) {
        if (pioGNodes[n].getLft() >= 0) {
            subtreedebugCheckCoalescences(pioGNodes, pioGNodes[n].getLft(), j, smcTree);
            subtreedebugCheckCoalescences(pioGNodes, pioGNodes[n].getRgt(), j, smcTree);
            smcTree.debugCheckCoalescenceIsThere(pioGNodes[n].getHeight(), pioGNodes[n].getUnion(), j);
        }
    }






}
