/*
Copyright (C) 2014 Graham Jones, www.indriid.com
*/
package stacey.util;

/**
 * Created by Graham Jones on 03/11/2014.
 */
/*
This is used by operator FocusedNodeHeightScaler to pass information
from all smcTree nodes to the gene trees so they can
calculate bounds for the scaling.

FSMoveSMCNodeUnions is used first, this is used later in the calculation
for the move.
 */

public class FSMoveSMCNodeInfo {
    private final BitUnion nodeUnion;
    private final BitUnion lftUnion;
    private final BitUnion rgtUnion;
    private final double logHeight;
    private final double weight;

    public FSMoveSMCNodeInfo(BitUnion nodeUnion, BitUnion lftUnion, BitUnion rgtUnion,
                             double logHeight, double weight) {
        this.nodeUnion = nodeUnion;
        this.lftUnion = lftUnion;
        this.rgtUnion = rgtUnion;
        this.logHeight = logHeight;
        this.weight = weight;
    }


    public BitUnion getNodeUnion() { return nodeUnion; }
    public BitUnion getLftUnion() { return lftUnion; }
    public BitUnion getRgtUnion() { return rgtUnion; }
    public double getLogHeight() { return logHeight; }
    public double getWeight() { return weight; }

}
